<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="robots" content="noodp" />
        <title>Rancher Multi-Cluster Management UI - AB Engineering Blog</title><meta name="description" content="It doesn&#39;t matter what Kubernetes Engine you use (EKS, AKS, GKE, RKE, K3s, etc), Rancher MCM will help you manage it better."><meta property="og:title" content="Rancher Multi-Cluster Management UI" />
<meta property="og:description" content="It doesn&#39;t matter what Kubernetes Engine you use (EKS, AKS, GKE, RKE, K3s, etc), Rancher MCM will help you manage it better." />
<meta property="og:type" content="article" />
<meta property="og:url" content="https://blog.alphabravo.io/posts/2021/rancher-multi-cluster-management-ui/" /><meta property="og:image" content="https://blog.alphabravo.io/assets/ab-seo-large.png" /><meta property="article:section" content="posts" />
<meta property="article:published_time" content="2021-11-17T13:00:00+00:00" />
<meta property="article:modified_time" content="2021-11-17T13:00:00+00:00" />

<meta name="twitter:card" content="summary_large_image"/>
<meta name="twitter:image" content="https://blog.alphabravo.io/assets/ab-seo-large.png"/>

<meta name="twitter:title" content="Rancher Multi-Cluster Management UI"/>
<meta name="twitter:description" content="It doesn&#39;t matter what Kubernetes Engine you use (EKS, AKS, GKE, RKE, K3s, etc), Rancher MCM will help you manage it better."/>
<meta name="application-name" content="AB Engineering Blog">
<meta name="apple-mobile-web-app-title" content="AB Engineering Blog"><link rel="shortcut icon" type="image/x-icon" href="/favicon.ico" />
        <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
        <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png"><link rel="apple-touch-icon" sizes="180x180" href="/apple-touch-icon.png"><link rel="manifest" href="/site.webmanifest"><link rel="canonical" href="https://blog.alphabravo.io/posts/2021/rancher-multi-cluster-management-ui/" /><link rel="prev" href="https://blog.alphabravo.io/posts/2021/why-we-use-rancher/" /><link rel="next" href="https://blog.alphabravo.io/posts/2021/why-we-chose-nifi-over-databrew/" /><link rel="stylesheet" href="/css/page.min.css"><link rel="stylesheet" href="/css/home.min.css"><script type="application/ld+json">
    {
        "@context": "http://schema.org",
        "@type": "BlogPosting",
        "headline": "Rancher Multi-Cluster Management UI",
        "inLanguage": "en",
        "mainEntityOfPage": {
            "@type": "WebPage",
            "@id": "https:\/\/blog.alphabravo.io\/posts\/2021\/rancher-multi-cluster-management-ui\/"
        },"image": ["https:\/\/blog.alphabravo.io\/assets\/ab-seo-large.png"],"genre": "posts","keywords": "rancher, kubernetes, rancher mcm","wordcount":  991 ,
        "url": "https:\/\/blog.alphabravo.io\/posts\/2021\/rancher-multi-cluster-management-ui\/","datePublished": "2021-11-17T13:00:00+00:00","dateModified": "2021-11-17T13:00:00+00:00","publisher": {
            "@type": "Organization",
            "name": "AlphaBravo","logo": "https:\/\/blog.alphabravo.io\/assets\/alphabravo-logoonly-outline1.png"},"author": {
                "@type": "Person",
                "name": "AB Engineering"
            },"description": "It doesn't matter what Kubernetes Engine you use (EKS, AKS, GKE, RKE, K3s, etc), Rancher MCM will help you manage it better."
    }
    </script></head><body data-header-desktop="auto" data-header-mobile="auto"><script>(window.localStorage && localStorage.getItem('theme') ? localStorage.getItem('theme') === 'dark' : ('' === 'auto' ? window.matchMedia('(prefers-color-scheme: dark)').matches : '' === 'dark')) && document.body.setAttribute('theme', 'dark');</script>

        <div id="mask"></div><div class="wrapper"><header class="desktop" id="header-desktop">
    <div class="header-wrapper">
        <div class="header-title">
            <a href="/" title="AB Engineering Blog"><img
        class="lazyload logo"
        src="/svg/loading.min.svg"
        data-src="/assets/alphabravo-logoonly-outline1.png"
        data-srcset="/assets/alphabravo-logoonly-outline1.png, /assets/alphabravo-logoonly-outline1.png 1.5x, /assets/alphabravo-logoonly-outline1.png 2x"
        data-sizes="auto"
        alt="/assets/alphabravo-logoonly-outline1.png"
        title="/assets/alphabravo-logoonly-outline1.png" /><span id="id-1" class="typeit"></span></a>
        </div>
        <div class="menu">
            <div class="menu-inner"><a class="menu-item" href="/" title="Blog Homepage"> Home </a><a class="menu-item" href="https://alphabravo.io" title="AlphaBravo Website" rel="noopener noreffer" target="_blank"> AB Website </a><a class="menu-item" href="/posts/"> Posts </a><a class="menu-item" href="https://github.com/AlphaBravoCompany" rel="noopener noreffer" target="_blank"><i class='fab fa-github fa-fw'></i>  </a><a class="menu-item" href="https://linkedin.com/company/alphabravogov/" rel="noopener noreffer" target="_blank"><i class='fab fa-linkedin fa-fw'></i>  </a><span class="menu-item delimiter"></span><span class="menu-item search" id="search-desktop">
                        <input type="text" placeholder="Search" id="search-input-desktop">
                        <a href="#" class="search-button search-toggle" id="search-toggle-desktop" title="Search">
                            <i class="fas fa-search fa-fw"></i>
                        </a>
                        <a href="#" class="search-button search-clear" id="search-clear-desktop" title="Clear">
                            <i class="fas fa-times-circle fa-fw"></i>
                        </a>
                        <span class="search-button search-loading" id="search-loading-desktop">
                            <i class="fas fa-spinner fa-fw fa-spin"></i>
                        </span>
                    </span><a class="menu-item" href="/index.xml" title="RSS"><i class="fas fa-rss fa-fw" title="RSS"></i> </a><a href="javascript:void(0);" class="menu-item theme-switch" title="Switch Theme">
                    <i class="fas fa-adjust fa-fw"></i>
                </a>
            </div>
        </div>
    </div>
</header><header class="mobile" id="header-mobile">
    <div class="header-container">
        <div class="header-wrapper">
            <div class="header-title">
                <a href="/" title="AB Engineering Blog"><img
        class="lazyload logo"
        src="/svg/loading.min.svg"
        data-src="/assets/alphabravo-logoonly-outline1.png"
        data-srcset="/assets/alphabravo-logoonly-outline1.png, /assets/alphabravo-logoonly-outline1.png 1.5x, /assets/alphabravo-logoonly-outline1.png 2x"
        data-sizes="auto"
        alt="/assets/alphabravo-logoonly-outline1.png"
        title="/assets/alphabravo-logoonly-outline1.png" /><span id="id-2" class="typeit"></span></a>
            </div>
            <div class="menu-toggle" id="menu-toggle-mobile">
                <span></span><span></span><span></span>
            </div>
        </div>
        <div class="menu" id="menu-mobile"><div class="search-wrapper">
                    <div class="search mobile" id="search-mobile">
                        <input type="text" placeholder="Search" id="search-input-mobile">
                        <a href="#" class="search-button search-toggle" id="search-toggle-mobile" title="Search">
                            <i class="fas fa-search fa-fw"></i>
                        </a>
                        <a href="#" class="search-button search-clear" id="search-clear-mobile" title="Clear">
                            <i class="fas fa-times-circle fa-fw"></i>
                        </a>
                        <span class="search-button search-loading" id="search-loading-mobile">
                            <i class="fas fa-spinner fa-fw fa-spin"></i>
                        </span>
                    </div>
                    <a href="#" class="search-cancel" id="search-cancel-mobile">
                        Cancel
                    </a>
                </div><a class="menu-item" href="/" title="Blog Homepage">Home</a><a class="menu-item" href="https://alphabravo.io" title="AlphaBravo Website" rel="noopener noreffer" target="_blank">AB Website</a><a class="menu-item" href="/posts/" title="">Posts</a><a class="menu-item" href="https://github.com/AlphaBravoCompany" title="" rel="noopener noreffer" target="_blank"><i class='fab fa-github fa-fw'></i></a><a class="menu-item" href="https://linkedin.com/company/alphabravogov/" title="" rel="noopener noreffer" target="_blank"><i class='fab fa-linkedin fa-fw'></i></a><div class="menu-item"><a href="/index.xml" title="RSS"><i class="fas fa-rss fa-fw" title="RSS"></i> </a>
                <span>&nbsp;|&nbsp;</span><a href="javascript:void(0);" class="theme-switch" title="Switch Theme">
                    <i class="fas fa-adjust fa-fw"></i>
                </a>
            </div></div>
    </div>
</header><div class="search-dropdown desktop">
    <div id="search-dropdown-desktop"></div>
</div>
<div class="search-dropdown mobile">
    <div id="search-dropdown-mobile"></div>
</div><main class="main">
                <div class="container"><div class="toc" id="toc-auto">
            <h2 class="toc-title">Contents</h2>
            <div class="toc-content" id="toc-content-auto"></div>
        </div><article class="page single" data-toc="disable"><div class="featured-image"><img
        class="lazyload"
        src="/svg/loading.min.svg"
        data-src="/assets/rancher-ui-full.png"
        data-srcset="/assets/rancher-ui-full.png, /assets/rancher-ui-full.png 1.5x, /assets/rancher-ui-full.png 2x"
        data-sizes="auto"
        alt="/assets/rancher-ui-full.png"
        title="It doesn&#39;t matter what Kubernetes Engine you use (EKS, AKS, GKE, RKE, K3s, etc), Rancher MCM will help you manage it better." /></div><div class="single-card" data-image="true"><h2 class="single-title animated flipInX">Rancher Multi-Cluster Management UI</h2><div class="post-meta">
                <div class="post-meta-line"><span class="post-author"><a href="/" title="Author" rel=" author" class="author"><i class="fas fa-user-circle fa-fw"></i>AB Engineering</a></span></div>
                <div class="post-meta-line"><span><i class="far fa-calendar-alt fa-fw"></i>&nbsp;<time datetime="2021-11-17">2021-11-17</time></span>&nbsp;<span><i class="fas fa-pencil-alt fa-fw"></i>&nbsp;991 words</span>&nbsp;
                    <span><i class="far fa-clock fa-fw"></i>&nbsp;5 minutes</span>&nbsp;</div>
            </div>
            
            <hr><div class="details toc" id="toc-static"  data-kept="">
                    <div class="details-summary toc-title">
                        <span>Contents</span>
                        <span><i class="details-icon fas fa-angle-right"></i></span>
                    </div>
                    <div class="details-content toc-content" id="toc-content-static"><nav id="TableOfContents">
  <ul>
    <li><a href="#what-is-rancher-multi-cluster-management">What is Rancher Multi-Cluster Management</a></li>
    <li><a href="#what-can-rancher-mcm-do">What Can Rancher MCM Do?</a></li>
    <li><a href="#deploying-rancher-mcm">Deploying Rancher MCM</a>
      <ul>
        <li><a href="#single-host-on-docker-non-ha">Single Host on Docker (Non HA)</a></li>
        <li><a href="#ha-deployment-of-kubernetes">HA Deployment of Kubernetes</a></li>
        <li><a href="#rancher-mcm---final-words">Rancher MCM - Final Words</a></li>
      </ul>
    </li>
  </ul>
</nav></div>
                </div><div class="content" id="content"><h2 id="what-is-rancher-multi-cluster-management">What is Rancher Multi-Cluster Management</h2>
<p>If you have ventured into container management and Kubernetes for your organization (or even for yourself), you have quickly realized that you need a robust way to manage more than one cluster easily. In fact, you probably want an easier way to manage a single cluster.</p>
<p>The official Kubernetes dashboard is&hellip; sub-optimal. There are a few other open-source options out there, but they lack in many areas. So what are we supposed to do?</p>
<pre tabindex="0"><code># Rancher has entered the chat.
</code></pre><p>This is where the Rancher UI, or <a href="https://rancher.com/products/rancher" target="_blank" rel="noopener noreffer">Rancher Multi-Cluster Manager</a> (Rancher MCM) comes into play.</p>
<p>As engineers responsible for a plethora of technologies, even just drilling down into Kubernetes space we usually have:</p>
<ul>
<li>A local Kubernetes cluster (k3d, k3s on a Raspberry Pi, or similar)</li>
<li>1-2 Dev clusters</li>
<li>1-N Test, QA, etc clusters</li>
<li>1-N Production clusters</li>
</ul>
<p>On each of those clusters we need:</p>
<ul>
<li>Monitoring &amp; Alerting</li>
<li>Logging</li>
<li>Backups</li>
<li>Direct access to Pod console and logs</li>
<li>Simplified deployment capabilities (Helm, etc) into each</li>
<li>Quick view into the health of the cluster</li>
<li>Much more</li>
</ul>
<p>This presents a problem because our time is already fragmented enough. We really need a unified interface that not only lowers the barrier to entry for less experienced Kubernetes users but also simplifies cluster and app administration for our fragmented attention.</p>
<hr>
<p><img
        class="lazyload"
        src="/svg/loading.min.svg"
        data-src="/assets/rancher-mcm-cluster-support.png"
        data-srcset="/assets/rancher-mcm-cluster-support.png, /assets/rancher-mcm-cluster-support.png 1.5x, /assets/rancher-mcm-cluster-support.png 2x"
        data-sizes="auto"
        alt="/assets/rancher-mcm-cluster-support.png"
        title="Rancher 2.6 - Create Cluster UI" /></p>
<hr>
<h2 id="what-can-rancher-mcm-do">What Can Rancher MCM Do?</h2>
<p>Rancher MCM has numerous capabilities that will make the developer, infrastructure, security and cluster-administrators life much easier.</p>
<p>Some of the key features of Rancher MCM are:</p>
<ul>
<li>
<p>Certified Distritbution Support: Rancher supports any certified Kubernetes distribution. For on-premises workloads, we offer the RKE. For the public cloud, we support all the major distributions, including EKS, AKS, and GKE. For edge, branch and desktop workloads we offer K3s, a certified lightweight distribution of Kubernetes.</p>
</li>
<li>
<p>Simplified Cluster Operations: Rancher provides simple, consistent cluster operations including provisioning, version management, visibility and diagnostics, monitoring and alerting, and centralized audit.</p>
</li>
<li>
<p>Security, Policy and User Management: Rancher lets you automate processes and applies a consistent set of user access and security policies for all your clusters, no matter where they’re running.</p>
</li>
<li>
<p>Shared Tools and Services: Rancher provides a rich catalog of services for building, deploying and scaling containerized applications, including app packaging, CI/CD, logging, monitoring and service mesh.</p>
</li>
</ul>
<hr>
<p><img
        class="lazyload"
        src="/svg/loading.min.svg"
        data-src="/assets/rancher-platform.png"
        data-srcset="/assets/rancher-platform.png, /assets/rancher-platform.png 1.5x, /assets/rancher-platform.png 2x"
        data-sizes="auto"
        alt="/assets/rancher-platform.png"
        title="/assets/rancher-platform.png" /></p>
<hr>
<h2 id="deploying-rancher-mcm">Deploying Rancher MCM</h2>
<p>There are 2 primary (<a href="https://rancher.com/docs/rancher/v2.6/en/installation/" target="_blank" rel="noopener noreffer">well-documented</a>) ways that we generally deploy Rancher MCM.</p>
<h3 id="single-host-on-docker-non-ha">Single Host on Docker (Non HA)</h3>
<ul>
<li><a href="https://rancher.com/docs/rancher/v2.6/en/installation/other-installation-methods/single-node-docker/" target="_blank" rel="noopener noreffer">Docker Install</a></li>
<li><a href="https://rancher.com/docs/rancher/v2.6/en/installation/other-installation-methods/single-node-docker/advanced/" target="_blank" rel="noopener noreffer">Docker Advanced Options</a></li>
</ul>
<p>There are many scenarios where we need to stand up a temporary or demo instance of Rancher. While the production, highly available method is to deploy the Helm chart onto a HA Kubernetes cluster, the simplest way to get started is to deploy Rancher as a Docker container.</p>
<p>Before you start, make sure you have a modern Linux distro running with a recent version of Docker running.</p>
<p>The simple command which includes local persistent storage is:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash">docker run -d --restart<span class="o">=</span>unless-stopped <span class="se">\
</span><span class="se"></span>  -p 80:80 -p 443:443 <span class="se">\
</span><span class="se"></span>  -v /opt/rancher:/var/lib/rancher <span class="se">\
</span><span class="se"></span>  --privileged <span class="se">\
</span><span class="se"></span>  rancher/rancher:latest

</code></pre></div><p>If you are running this on a public server, you can also automatically deploy this and get a valid SSL certificate from Let&rsquo;s Encrypt using the following command.</p>
<p>Make sure that the following is configured:</p>
<ul>
<li>Open port 80 from the internet to your server</li>
<li>Configure the &lt;YOUR.DNS.NAME&gt; that you enter below to point to the public IP of your server</li>
</ul>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash">docker run -d --restart<span class="o">=</span>unless-stopped <span class="se">\
</span><span class="se"></span>  -p 80:80 -p 443:443 <span class="se">\
</span><span class="se"></span>  -v /opt/rancher:/var/lib/rancher <span class="se">\
</span><span class="se"></span>  --privileged <span class="se">\
</span><span class="se"></span>  rancher/rancher:latest
  --acme-domain &lt;YOUR.DNS.NAME&gt;

</code></pre></div><p>Check out the documentation for additional advanced deployment options for the Rancher Single Node Docker Install</p>
<p><em>Fun Fact: The Docker Install actually deploys a K3d Single Node Cluster under to the hood to run the Rancher MCM UI on top of</em></p>
<h3 id="ha-deployment-of-kubernetes">HA Deployment of Kubernetes</h3>
<ul>
<li><a href="https://rancher.com/docs/rancher/v2.6/en/installation/install-rancher-on-k8s/" target="_blank" rel="noopener noreffer">Rancher on K8s</a></li>
<li><a href="https://rancher.com/docs/rancher/v2.6/en/installation/other-installation-methods/single-node-docker/advanced/" target="_blank" rel="noopener noreffer">Docker Advanced Options</a></li>
</ul>
<p>Assuming you have a HA (at least 3 master node) Kubernetes cluster up and running already, you can deploy Rancher on top of that to provide you with a HA deployment of you Rancher MCM. In this instance, we will use the Rancher self generated SSL cert, but you can refer to the docs for apply your own SSL certificates.</p>
<p>Before you get started you will need:</p>
<ul>
<li>A HA Kubernetes Cluster. Any one will do.</li>
<li>Helm installed locally</li>
</ul>
<p>First, you need to install cert-manager in your cluster:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash"><span class="c1"># If you have installed the CRDs manually instead of with the `--set installCRDs=true` option added to your Helm install command, you should upgrade your CRD resources before upgrading the Helm chart:</span>
kubectl apply -f https://github.com/jetstack/cert-manager/releases/download/v1.5.1/cert-manager.crds.yaml

<span class="c1"># Add the Jetstack Helm repository</span>
helm repo add jetstack https://charts.jetstack.io

<span class="c1"># Update your local Helm chart repository cache</span>
helm repo update

<span class="c1"># Install the cert-manager Helm chart</span>
helm install cert-manager jetstack/cert-manager <span class="se">\
</span><span class="se"></span>  --namespace cert-manager <span class="se">\
</span><span class="se"></span>  --create-namespace <span class="se">\
</span><span class="se"></span>  --version v1.5.1

</code></pre></div><p>We can verify cert-manager is installed by running:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash">kubectl get pods --namespace cert-manager
</code></pre></div><p>Next, we can install Rancher:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash"><span class="c1"># Add the Rancher Helm repository</span>
helm repo add rancher-stable https://releases.rancher.com/server-charts/stable

<span class="c1"># Create the Rancher Namespace</span>
kubectl create namespace cattle-system

<span class="c1"># Install the Rancher Helm chart</span>
helm install rancher rancher-stable/rancher <span class="se">\
</span><span class="se"></span>  --namespace cattle-system <span class="se">\
</span><span class="se"></span>  --set <span class="nv">hostname</span><span class="o">=</span>rancher.my.org <span class="se">\
</span><span class="se"></span>  --set <span class="nv">bootstrapPassword</span><span class="o">=</span>admin
</code></pre></div><p>We can verify our rancher deployment using the following command:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash">kubectl -n cattle-system rollout status deploy/rancher
</code></pre></div><p>Now you should be able to visit <code>https://rancher.my.org</code> and access the cluster.</p>
<p>You can now begin to import additional clusters, select existing clusters to explore and deploy new resources.</p>
<p>Here are some videos to get you started with the Rancher 2.6 Interface:</p>
<ul>
<li><a href="https://www.youtube.com/watch?v=e3qbjX8StvU" target="_blank" rel="noopener noreffer">Rancher Online Meetup - September 2021 - Introducing SUSE Rancher 2.6</a></li>
<li><a href="https://www.youtube.com/watch?v=_dn4c9j7LUo" target="_blank" rel="noopener noreffer">What&rsquo;s New in Rancher 2.6?</a></li>
<li><a href="https://www.youtube.com/watch?v=bpc-z1GMivA&amp;t=4410s" target="_blank" rel="noopener noreffer">Rancher 2.6 UI Walkthrough and Q&amp;A</a></li>
</ul>
<h3 id="rancher-mcm---final-words">Rancher MCM - Final Words</h3>
<p>Hopefully, this post provided you with some insight into how valuable the Rancher MCM UI can be to your organization and helped you get started deploying it into your environment.</p>
<p>Please reach out to us if you have any questions regarding installing Rancher or if you need any help running your DevSecOps systems.</p>
<p>Thanks for reading!</p>
<hr>
<p><em>The AB Engineering Team</em></p>
<p><strong>Website:</strong> <a href="https://alphabravo.io" target="_blank" rel="noopener noreffer">https://alphabravo.io</a></p>
<p><strong>Contact Us:</strong> <a href="https://alphabravo.io/contact-us" target="_blank" rel="noopener noreffer">https://alphabravo.io/contact-us</a></p>
</div><div class="post-footer" id="post-footer">
    <div class="post-info"><div class="post-info-tag"><span><a href="/tags/rancher/">rancher</a>
                </span><span><a href="/tags/kubernetes/">kubernetes</a>
                </span><span><a href="/tags/rancher-mcm/">rancher mcm</a>
                </span></div><div class="post-info-line"><div class="post-info-mod">
                <span>Updated on 2021-11-17</span>
            </div><div class="post-info-mod"></div>
        </div></div><div class="post-nav"><a href="/posts/2021/why-we-use-rancher/" class="prev" rel="prev" title="Why We Use Rancher"><i class="fas fa-angle-left fa-fw"></i>Previous Post</a>
            <a href="/posts/2021/why-we-chose-nifi-over-databrew/" class="next" rel="next" title="Why We Chose Nifi Over Databrew">Next Post<i class="fas fa-angle-right fa-fw"></i></a></div></div>
</div></article></div>
            </main>
            <footer class="footer"><div class="footer-container"><div class="footer-line">AlphaBravo</div><div class="footer-line" itemscope itemtype="http://schema.org/CreativeWork"><i class="far fa-copyright fa-fw"></i><span itemprop="copyrightYear">2021</span><span class="author" itemprop="copyrightHolder">&nbsp;<a href="/"></a></span></div>
</div>
</footer>
        </div>

        <div id="fixed-buttons"><a href="#" id="back-to-top" class="fixed-button" title="Back to Top">
                <i class="fas fa-chevron-up fa-fw"></i>
            </a></div><link rel="stylesheet" href="/lib/fontawesome-free/all.min.css"><link rel="stylesheet" href="/lib/animate/animate.min.css"><link rel="stylesheet" href="/lib/lightgallery/lightgallery.min.css"><link rel="stylesheet" href="/lib/cookieconsent/cookieconsent.min.css"><script src="/lib/autocomplete/autocomplete.min.js"></script><script src="/lib/lunr/lunr.min.js"></script><script src="/lib/lazysizes/lazysizes.min.js"></script><script src="/lib/typeit/typeit.min.js"></script><script src="/lib/lightgallery/lightgallery.min.js"></script><script src="/lib/lightgallery/lg-thumbnail.min.js"></script><script src="/lib/lightgallery/lg-zoom.min.js"></script><script src="/lib/clipboard/clipboard.min.js"></script><script src="/lib/cookieconsent/cookieconsent.min.js"></script><script>window.config={"code":{"copyTitle":"Copy to clipboard","maxShownLines":100},"comment":{},"cookieconsent":{"content":{"dismiss":"Ok","link":"https://alphabravo.io","message":"We use cookies and open-source, privacy-respecting analytics technologies to improve your browsing experience on our website, to analyze our website traffic, and to understand where our visitors are coming from."},"enable":true,"palette":{"button":{"background":"#f0f0f0"},"popup":{"background":"#1aa3ff"}},"theme":"edgeless"},"data":{"id-1":"Engineering Blog","id-2":"Engineering Blog"},"lightGallery":{"actualSize":false,"exThumbImage":"data-thumbnail","hideBarsDelay":2000,"selector":".lightgallery","speed":400,"thumbContHeight":80,"thumbWidth":80,"thumbnail":true},"search":{"highlightTag":"em","lunrIndexURL":"/index.json","maxResultLength":10,"noResultsFound":"No results found","snippetLength":30,"type":"lunr"},"typeit":{"cursorChar":null,"cursorSpeed":null,"data":{"id-1":["id-1"],"id-2":["id-2"]},"duration":null,"speed":null}};</script><script src="/js/theme.min.js"></script><script data-goatcounter="https://stats.alphabravo.io/count" async src="//stats.alphabravo.io/count.js"></script></body></html>
